"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const queue_1 = require("./queue");
const chai_1 = require("chai");
const mock_knex_1 = __importDefault(require("mock-knex"));
const knex_1 = __importDefault(require("knex"));
require("mocha");
const db = knex_1.default({
    client: 'postgresql',
    connection: {
        database: 'loqueue_test' || process.env.POSTGRES_DB,
        user: 'postgres' || process.env.POSTRGES_USER,
        password: '' || process.env.POSTGRES_PASS
    }
});
const tracker = mock_knex_1.default.getTracker();
describe('queue', () => {
    it('should successfully add and delete', () => __awaiter(void 0, void 0, void 0, function* () {
        const q = new queue_1.Queue('test-queue', db);
        const job = yield q.add({
            test: 'hello-world'
        });
        yield job.remove();
    }));
    it('should process jobs', (done) => {
        (() => __awaiter(void 0, void 0, void 0, function* () {
            const q = new queue_1.Queue('test-queue', db);
            q.process((j) => __awaiter(void 0, void 0, void 0, function* () {
                chai_1.expect(j).to.not.be.equal(null);
                chai_1.expect(j.test).to.be.equal('hello-world');
                done();
                return null;
            }));
            try {
                const job = yield q.add({
                    test: 'hello-world'
                });
            }
            catch (err) {
                console.log('as', err);
            }
            // await job.remove()
        }))();
    });
    after(() => {
        setImmediate(() => {
            console.log('bye database');
            db.destroy();
        });
    });
});
